struct list_struct
{
	void			*data;
	struct list_struct	*next;
};
typedef struct list_struct List;
typedef List *LISTPTR;

#ifndef NOBALLOC
extern struct BlockHeap	*list_heap;
#endif

/* prototypes */
extern LISTPTR list_add_ptr(LISTPTR *, void *);
extern void list_add_link(void *, LISTPTR, LISTPTR *);
extern void list_del_ptr(LISTPTR *, void *);
extern void list_del_key(LISTPTR *, char *);
extern void list_del_link(LISTPTR, LISTPTR *);
extern LISTPTR list_find_key(LISTPTR *, char *);
extern LISTPTR list_find_ptr(LISTPTR *, void *);
extern int dupe_check(LISTPTR, const char *, const char *);
extern void unmark_dupe(LISTPTR, const char *, const char *);
extern void list_init(void);
