extern void parse(char *);
/* 
 * Message table structure 
 */
struct  Message
{
  char  *cmd;
  void   (* func)(int, char **);
  int   parameters;
};

struct MessageTree
{
  char*               final;
  struct Message*     msg;
  struct MessageTree* pointers[26];
}; 

typedef struct MessageTree MESSAGE_TREE;

#define MAXPARA    10

extern void m_admin(int,char **);
extern void m_mode(int,char **);
extern void m_ping(int,char **);
extern void m_nick(int,char **);
extern void m_privmsg(int,char **);
extern void m_quit(int,char **);
extern void m_info(int,char **);
extern void m_kill(int,char **);
extern void m_server(int,char **);
extern void m_stats(int,char **);
extern void m_version(int, char **);
extern void m_squit(int, char **);
extern void m_351(int, char **);
extern void m_capab(int, char **);

#ifdef MSGTAB
struct Message msgtab[] = {
  { "PRIVMSG", m_privmsg,  MAXPARA },
  { "NICK",    m_nick,     MAXPARA },
  { "MODE",    m_mode,     MAXPARA },
  { "QUIT",    m_quit,     MAXPARA },
  { "PING",    m_ping,     MAXPARA },
  { "KILL",    m_kill,     MAXPARA },
  { "SERVER",  m_server,   MAXPARA },
  { "SQUIT",   m_squit,    MAXPARA },
  { "VERSION", m_version,  MAXPARA },
  { "STATS",   m_stats,    MAXPARA },
  { "ADMIN",   m_admin,    MAXPARA },
  { "INFO",    m_info,     MAXPARA },
  { "CAPAB",   m_capab,    MAXPARA },
  { (char *) 0, (void (*)(int, char **)) 0 }
};

struct MessageTree* msg_tree_root;
#else
extern struct Message       msgtab[];
extern struct MessageTree*  msg_tree_root;
#endif

extern struct Message *do_msg_tree(MESSAGE_TREE *mtree, char *prefix, struct Message *mptr);
extern int mcmp(struct Message *m1, struct Message *m2);
extern void init_tree_parse(struct Message *);

