#include "alcstats.h"

#ifdef USE_RRD
#include "rrdtool.h"
#include <rrd.h>

#define MAXRRD 19

/* ircd's strig_to_array modified for rrd parsing */
static inline int rrd_s2a(char *string, char *parv[MAXRRD])
{
	char *p;
	char *buf = string;
	int x = 0;

	while (*buf == ' ') /* skip leading spaces */
		buf++;

	if (*buf == '\0') /* ignore all-space args */
		return(x);

	do {
		parv[x++] = buf;
		parv[x]   = NULL;

		if ((p = strchr(buf, ' ')) != NULL) {
			*p++ = '\0';
			buf  = p;
		} else
			return(x);

		while (*buf == ' ')
			buf++;

		if (*buf == '\0')
			return(x);
	} while (x < MAXRRD - 1);

	parv[x++] = p;
	parv[x]   = NULL;
	return(x);
}

void makerrd(const char *file)
{
	struct stat	buf;
	char		filename[1024+1];
	char		tmpbuf[8196+1];
	char		*parv[MAXRRD];
	unsigned int	parc;
	unsigned long	heartbeat;

	snprintf(filename, 1024+1, "%s/%s.rrd", conf.rrddir, file);
	if (stat(filename, &buf)<0) {
		heartbeat = (unsigned long)conf.calctime*2;
		snprintf(tmpbuf, 8196+1, "rrdtool %s --start %ld --step %lu DS:users:GAUGE:%lu:0:150000 DS:dupes:GAUGE:%lu:0:150000 DS:unique:GAUGE:%lu:0:150000 DS:opers:GAUGE:%lu:0:150000 RRA:AVERAGE:0.5:1:800 RRA:AVERAGE:0.5:%ld:800 RRA:AVERAGE:0.5:%ld:800 RRA:AVERAGE:0.5:%ld:800 RRA:MAX:0.5:1:800 RRA:MAX:0.5:%ld:800 RRA:MAX:0.5:%ld:800 RRA:MAX:0.5:%ld:800", filename, (now-10), (unsigned long)conf.calctime, heartbeat, heartbeat, heartbeat, heartbeat, 30UL/(conf.calctime/60), 120UL/(conf.calctime/60), 1440UL/(conf.calctime/60), 30UL/(conf.calctime/60), 120UL/(conf.calctime/60), 1440UL/(conf.calctime/60));
		parc = rrd_s2a(tmpbuf, parv);
		rrd_create(parc, parv);
		clear_opts();
	}
}

void updaterrd(const char *file, int users, int dupes, int opers)
{
	char		filename[1024+1];
	char		tmpbuf[8196+1];
	char		*parv[MAXRRD];
	int		parc;

	snprintf(filename, 1024+1, "%s/%s.rrd", conf.rrddir, file);
	snprintf(tmpbuf, 8196+1, "rrdtool %s %ld:%d:%d:%d:%d", filename, now, users, dupes, (users-dupes), opers);
	parc = rrd_s2a(tmpbuf, parv);
	rrd_update(parc, parv);
	clear_opts();
}

void deleterrd(const char *file)
{
	char	tmpbuf[PATH_MAX+1];

	snprintf(tmpbuf, PATH_MAX+1, "%s/%s.rrd", conf.rrddir, file);
	unlink(tmpbuf);
}
#endif
